#ifndef DynamicFunctions_H
#define DynamicFunctions_H


#include "../Inputs/Inputs.h"
#include "../DataFolder.h"
#include <vector>
#include <iostream>
#include <numeric>
#include <string>


class DynamicFunctions
{
public:

	static double ecdf(const std::vector<double>& DataRecord, double x);
	static double quantile(const std::vector<double>& DataRecord, double percentile, Inputs* input);
	static double LCEventload(const std::vector<double>& DataRecord, const std::vector<double>& ECVector, double Eventdata, double cell_num, Inputs* input);
	//data rececord is matched with year record e.g. input data row: 1 1 [1993] [5]
	static void YearAverage(const std::vector<double>& DataRecord, const std::vector<int>& YearRecord, Inputs* input);
	static void ECDynamicOutputwriter(const std::vector<double>& result, const std::vector<int>& Year, Inputs* input, const std::string& pollutant);
	static void Interpolation(const std::vector<double>& DataRecord,Inputs* input);
	//Define DataRecordSorted here to ler it to be public
	//static std::vector<double> DataRecordSorted;
	//static void extendEC(double ECtail);
	static vector< vector<double> > pollutant_landcover_list;
};


#endif