#include "LandCoverPCal.h"
// This function is where the 'gap' for Cool Air when IC+TC<100 is defined as different land cover. RC 10/2020
void LandCoverPCal::CalLandCover(Inputs *input, DataFolder *folder, int i)
{

	folder->ParamDict["TreeP"] = input->TreeCoverdata[i] / 100;
	folder->ParamDict["ImperP"] = input->ImperCoverdata[i] / 100;
	
	folder->ParamDict["landc"] = input->NLCDLandCoverData[i];
	double landc = folder->ParamDict["landc"];
	double TotalCover = folder->ParamDict["TreeP"] + folder->ParamDict["ImperP"];
	folder->ParamDict["TreeOnImp"] = 0.0; //not being used
	if (TotalCover > 1) // If TC+IC>100%, then make excess 'Tree Under Impervious'.
	{
		folder->ParamDict["ImperP"] = folder->ParamDict["ImperP"] - (TotalCover - 1);
		folder->ParamDict["TreeOnImp"] = TotalCover - 1;
		folder->ParamDict["SoilP"] = 0;
		folder->ParamDict["WaterP"] = 0;
		folder->ParamDict["ShortVegP"] = 0;
		folder->ParamDict["ConnectedImper"] = 0.50; //not used
	}
	else // If TC+IC<100%, fill remaining land cover based on NLCD Land Cover Class
	{

		if (landc == 11 || landc == 12)
		{
			folder->ParamDict["WaterP"] = 1 - TotalCover;
			folder->ParamDict["SoilP"] = 0;
			folder->ParamDict["ShortVegP"] = 0;
			folder->ParamDict["ConnectedImper"] = 0;
		}

		else if (landc == 31)
		{
			folder->ParamDict["SoilP"] = 1 - TotalCover;
			folder->ParamDict["WaterP"] = 0;
			folder->ParamDict["ShortVegP"] = 0;
			folder->ParamDict["ConnectedImper"] = 0;
			//folder->ParamDict["ShortVegP"]=1-TotalCover;
			// folder->ParamDict["WaterP"]=0;
			// folder->ParamDict["SoilP"]=0;	
			//folder->ParamDict["ConnectedImper"]=0.50;
		}
		//Added the code to calculate folder->ParamDict["ShortVegP"], folder->ParamDict["WaterP"], folder->ParamDict["SoilP"], folder->ParamDict["ConnectedImper"] for differenct NLCD values as per the inputs provided by Ted
		else if (landc == 51 || landc == 52 || landc == 71 || landc == 72 || landc == 73 || landc == 74 || landc == 81 || landc == 82)
		{
			folder->ParamDict["ShortVegP"] = 1 - TotalCover;
			folder->ParamDict["ShortVegP"] = folder->ParamDict["ShortVegP"] * 0.85;
			folder->ParamDict["WaterP"] = 0;
			folder->ParamDict["SoilP"] = folder->ParamDict["ShortVegP"] * 0.15;
			folder->ParamDict["ConnectedImper"] = 0.10;
		}
		else if (landc == 90)
		{
			folder->ParamDict["ShortVegP"] = 1 - TotalCover;
			folder->ParamDict["ShortVegP"] = folder->ParamDict["ShortVegP"] * 0.25;
			folder->ParamDict["WaterP"] = folder->ParamDict["ShortVegP"] * 0.75;
			folder->ParamDict["SoilP"] = 0;
			folder->ParamDict["ConnectedImper"] = 0.10;
		}
		else if (landc == 95)
		{
			folder->ParamDict["ShortVegP"] = 1 - TotalCover;
			folder->ParamDict["ShortVegP"] = folder->ParamDict["ShortVegP"] * 0.75;
			folder->ParamDict["WaterP"] = folder->ParamDict["ShortVegP"] * 0.25;
			folder->ParamDict["SoilP"] = 0;
			folder->ParamDict["ConnectedImper"] = 0.10;
		}
		//End of changes 
		//added if condition by Vamsi to avoid assigning ShortVeg if the inputs are no values
		else if (landc == -9999)
		{
			folder->ParamDict["ShortVegP"] = 0;
		}
		else // If NLCD LC is not one of the special classes defined above, use the following for filling in 'gap'=100%-TC%-IC%.
		{
			folder->ParamDict["ShortVegP"] = 1 - TotalCover;
			folder->ParamDict["WaterP"] = 0;
			folder->ParamDict["SoilP"] = folder->ParamDict["ShortVegP"] / 2;
			folder->ParamDict["ShortVegP"] = folder->ParamDict["ShortVegP"] / 2;
			folder->ParamDict["ConnectedImper"] = 0.50; // RC 4/2020, According to comment on ln20 for IC+TC>100%, ConnectedImper is not used.
		}
	}


}
//void LandCoverPCal::CalAveHeight()
//
//{   
//	aveHeight=inp->pm->get_tree_height()*TreeP+inp->pm->get_building_height21()+inp->pm->get_short_height()*folder->ParamDict["ShortVegP"];
//    if (landc==22)
//	aveHeight=inp->pm->get_tree_height()*TreeP+inp->pm->get_building_height22()+inp->pm->get_short_height()*folder->ParamDict["ShortVegP"];
//	if (landc==23)
//	aveHeight=inp->pm->get_tree_height()*TreeP+inp->pm->get_building_height23()+inp->pm->get_short_height()*folder->ParamDict["ShortVegP"];
//	if (landc==24)
//	aveHeight=inp->pm->get_tree_height()*TreeP+inp->pm->get_building_height24()+inp->pm->get_short_height()*folder->ParamDict["ShortVegP"];
//
//}