#ifndef LANDCOVERPCAL_H
#define LANDCOVERPCAL_H
//////////////////////////////////////////////////////////////////////////////////////
//																		            //
// LANDCOVERPCAL.h - Calculate land cover percentages for each folder                 //																		   
// ver 1.0                                                                          //
// Language:    Visual C++ 2010                                                     //
// Platform:                     										            //
// Application: iTree-Temperature, Summer 2014                                      //
// Programmer: Yang Yang, yyang3117@gmail.com				                        //																	   	
//////////////////////////////////////////////////////////////////////////////////////
/*
  

  Module Operations: 
  ==================
  constructor: WatershedData(Params &pa)  
  This class is to read the spatial information of a watershed
  DEM
  Land cover
  Impervious cover
  Tree canopy cover
  calculate the slope, aspect, accumulation area, TIe, TIn
  and assign these values to folders within the watershed

  Public Interface:
  =================
  WatershedData waterD(&pa);
  

  Build Process:
  ==============
  Required files
    - InputWatershed.cpp
	
  Build commands 
    - devenv PASATH.sln
   
  Maintenance History:
  ====================
      ver 1.0 : March 2014
        - first release
		 
 */



#include <string>
#include <iomanip>
#include <cstdlib>
#include <sys/stat.h>

#include <vector>
#include <math.h>
#include "../Inputs/Inputs.h"
#include "../DataFolder.h"
//#include "TemperatureHydroPrime.h"

class LandCoverPCal
{

  public:
	    
	  // i is the index of the folder
	  static void CalLandCover(Inputs *input, DataFolder *folder, int index);
};

#endif