#ifndef IMPDEPSTOR_H
#define IMPDEPSTOR_H
///////////////////////////////////////////////////////////////////////////////////////
//																		             //
// ImperviousDepressionStorageCalc.h - Calculates Impervious runoff                                           //																		   
// ver 1.0                                                                           //
// Language:    Visual C++ 2010                                                      //
// Platform:    MacBookPro5,4  Win7										             //
// Application: HydroPrime/iHydro Version6, Summer 2012                              //
// Programmer:  				             //																	   	
///////////////////////////////////////////////////////////////////////////////////////
/*
  Origin:
  ==================
  Program: iHydro Version 5
  
  Source Code File(s): rImpervious.cpp
  Functions:           V5 - (line 81) Treeintercept()
  
  Author(s): Jun Wang, jwang06@mailbox.syr.edu, V4/V4.5
			 Yang Yang, yyang31@syr.edu, V5
			  	
						*Incorporated calculations into new architecture
  Creation Date: Impervious Forest effect, Spring 2004 

  Publication(s): 

  Module Operations: 
  ==================
  

  Public Interface:
  =================
  ImperviousDepressionStorageCalc(Inputs *input, Repo *repo);
  void calculate(Inputs *input, DataFolder *folder, int timeStep);

  Build Process:
  ==============
  Required files
	-ICalc.h, InputsRepository.h, ResultsRepository.h, TreeInterception.cpp 
				
  Build commands 
    - devenv hydroprime.sln
   
  Maintenance History:
  ====================
  */

#include "../Inputs/Inputs.h"
#include "../DataFolder.h"
#include <map>
#include "../GI/GI_Outlets.h"


class ImperviousDepressionStorageCalc
{
	public:
		
		static void calculateImpEvapTemperature(Inputs * input, DataFolder *folder, int timeStep);
		static void calculateImpEvapStatistical(Inputs * input, DataFolder *folder, int timeStep);
		static void calculate(Inputs *input, DataFolder *folder, int timeStep, std::map<std::string, void(*)(Inputs *input, DataFolder *folder, int timeStep)> &functors);
		static void storeValues(Inputs *input, DataFolder *folder, int timeStep);
};



#endif