#ifndef INFILEXPDECAY_H
#define INFILEXPDECAY_H

//////////////////////////////////////////////////////////////////////////////////
//																		        //
// InfiltrationExpDecay.h - Calculates infitration							    //																		   
// ver 1.0                                                                      //
// Language:    Visual C++ 2010                                                 //
// Platform:    MacBookPro5,4  Win7										        //
// Application: HydroPrime/iHydro Version6, Summer 2012                         //
// Programmer:  				        //																	   	
//////////////////////////////////////////////////////////////////////////////////
/*
  Origin:
  ==================
  Program: iHydro Version 5 & iHydro Version 4.5
  
  Source Code File(s): sInfiltrationE.cpp, sInfiltration.cpp 
  
  Author(s): Jun Wang, jwang06@mailbox.syr.edu, Original author 
			  	
						*Incorporated calculations into new architecture
  Creation Date: Summer 2000

  Publication(s): Jun Wang PHDThesis

  Module Operations: 
  ==================
  ...

  Public Interface:
  =================
  SoilInfiltrationCalc(Inputs *input, Repo *repo);
  void calculate(Inputs *input, DataFolder *folder, int timeStep);

  Build Process:
  ==============
  Required files
	-ICalc.h, InputsRepository.h, ResultsRepository.h, Infiltration.cpp 
				
  Build commands 
    - devenv hydroprime.sln
   
  Maintenance History:
  ====================

 */
#include "../Inputs/Inputs.h"
#include "../DataFolder.h"

class SoilInfiltrationExpDecayCalc
{
	public:
		static void calculate(Inputs *input, DataFolder *folder, int timeStep);


	private:
		static void beforePonding(int bIT, double bR, double bDT, DataFolder* folder, Inputs *input, int timeStep);
		static void estimateTP(int tpIT, double tpR, double tpDT, DataFolder* folder, Inputs *input, int timeStep);
		static void inPonding(int ipIT, double ipPP, double ipDT, DataFolder *folder, Inputs *input);
		static void prepPonding(int ipIT, double ipPP, double ipDT, DataFolder *folder, Inputs *input);
		static void noPonding(double npR, DataFolder* folder, Inputs *input, int timeStep);
		static void infilEXQ(double ifR, DataFolder* folder, Inputs *input, int timeStep);

};



#endif