#ifndef SHORTVEGINTERCEPT_H
#define SHORTVEGINTERCEPT_H
///////////////////////////////////////////////////////////////////////////////////////
//																		             //
// ShortVegInterception.h - Calculates short veg interception                        //																		   
// ver 1.0                                                                           //
// Language:    Visual C++ 2010                                                      //
// Platform:    MacBookPro5,4  Win7										             //
// Application: HydroPrime/iHydro Version6, Summer 2012                              //
// Programmer:  				             //																	   	
///////////////////////////////////////////////////////////////////////////////////////
/*
  Origin:
  ==================
  Program: iHydro Version 5
  
  Source Code File(s): VegInterception.cpp
  Functions:           V5 - (line 111) ShortVegintercept()
  
  Author(s): Yang Yang, yyang31@syr.edu, V5
			  	
						*Incorporated calculations into new architecture
  Creation Date: 03 June 2010

  Publication(s): 

  Module Operations: 
  ==================
  

  Public Interface:
  =================
  ShortVegInterceptionCalc(Inputs *input, Repo *repo);
  void calculate(Inputs *input, DataFolder *folder, int timeStep);

  Build Process:
  ==============
  Required files
	-ICalc.h, InputsRepository.h, ResultsRepository.h, ShortVegInterception.cpp 
				
  Build commands 
    - devenv hydroprime.sln
   
  Maintenance History:
  ====================
  */



#include "..\Inputs\Inputs.h"
#include "..\DataFolder.h"

class ShortVegInterceptionCalc
{
	public:
		static void calculate(Inputs *input, DataFolder *folder, int timeStep);


	private:
		static void shortVegInterceptionRain(Inputs *input, DataFolder *folder, int timeStep);
		static void shortVegInterceptionSnow(Inputs *input, DataFolder *folder, int timeStep);
		static void shortVegUnloadSnow(Inputs *input, DataFolder *folder, int timeStep);
		static void shortVegSnowMeltbyRn(Inputs *input, DataFolder *folder, int timeStep);
		static void storeValues(Inputs *input, DataFolder *folder, int timeStep);


};



#endif