#include "CoolRiverOutputWriter.h"

void CoolRiverOutputWriter::calculationMethod1(Inputs* input, std::string inputDirectory, StreamTemperature* st, int& calcMethod, int& TotalDistMod_CN, int& TotalTimeMod_CN)
{
	std::vector<vector<double>> modeledT_x0(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> skyViewFactorE(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> skyViewFactorW(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> atmLW(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> landCoverLW(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> upToAirLW(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> LW(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> latent(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> sensible(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> sediment(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> thermalExchange(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> SW(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> dirSW(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	std::vector<vector<double>> diffSW(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN));
	//std::vector<vector<double>> t_minBased1(TotalDistMod_CN, std::vector<double>(TotalTimeMod_CN * 60));

	//as 20210113 We may need to move this section of the code to CoolRiverCalcMethod.cpp in ProcAndCalcs and CoolRiver
	if (calcMethod == 1)
	{
		// For Steady State
		modeledT_x0 = st->getModT();
		dirSW = st->getSWDir_2D();
		diffSW = st->getSWDiff_2D();
		atmLW = st->getAtmLW();
		landCoverLW = st->getLcLW();
		upToAirLW = st->getBackLW();
		LW = st->getLW();
		latent = st->getLatent();
		sensible = st->getSensible();
		sediment = st->getBed();
		thermalExchange = st->getHeatFlux();
		SW = st->getSW();
		//t_minBased1 = st->getT_MinBased();
	}

}

void CoolRiverOutputWriter::calculationMethod2(Inputs* input, std::string inputDirectory, StreamTemperature* st, int &calcMethod, int &TotalDistMod_FD, int &TotalTimeUns, int &TotalDist_Uns, int &TotalTimeMod)
{
	std::vector<vector<double>> Flux_Total_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Flux_Conduction_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Flux_Evaporation_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Flux_Convection_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> FLux_AtmLW_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Flux_LCLW_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Flux_BackLW_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Flux_LW_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Flux_DirSW_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Flux_DiffSW_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Flux_SW_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> T_Uns_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Depth_Uns_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Pw_unsteady_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> width_UnsTotal_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> depth_AvgUns_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Hyporheic_Exchange_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));
	std::vector<vector<double>> Rh_unsteady_copy(TotalDistMod_FD, std::vector<double>(TotalTimeUns));

	std::vector<vector<double>> temp_Flux_Total(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Flux_Conduction(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Flux_Evaporation(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Flux_Convection(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_FLux_AtmLW(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Flux_LCLW(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Flux_BackLW(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Flux_LW(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Flux_DirSW(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Flux_DiffSW(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Flux_SW(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_T_Uns(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_depth_Uns(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Pw_unsteady(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_width_UnsTotal(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_depth_AvgUns(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Hyporheic_Exchange(TotalDist_Uns, std::vector<double>(TotalTimeMod));
	std::vector<vector<double>> temp_Rh_unsteady(TotalDist_Uns, std::vector<double>(TotalTimeMod));

	//std::vector<double> temp_Hyporheic_Exchange(TotalDist_Uns);
	//std::vector<double> temp_Q_GW(TotalDist_Uns);

	if (calcMethod == 2)
	{
		// For Unsteady state
		Flux_Total_copy = st->get_TotalFlux();
		Flux_Conduction_copy = st->get_Conduction();
		Flux_Evaporation_copy = st->get_Evaporation();
		Flux_Convection_copy = st->get_Convection();
		FLux_AtmLW_copy = st->get_AtmLW();
		Flux_LCLW_copy = st->get_LCLW();
		Flux_BackLW_copy = st->get_BackLW();
		Flux_LW_copy = st->get_Flux_LW();
		Flux_DirSW_copy = st->get_Flux_DirSW();
		Flux_DiffSW_copy = st->get_Flux_DiffSW();
		Flux_SW_copy = st->get_Flux_SW();
		T_Uns_copy = st->get_T_Uns();
		Depth_Uns_copy = st->get_depth_Uns();

		temp_Flux_Total = st->get_hour_TotalFlux();
		temp_Flux_Conduction = st->get_hour_Conduction();
		temp_Flux_Evaporation = st->get_hour_Evaporation();
		temp_Flux_Convection = st->get_hour_Convection();
		temp_FLux_AtmLW = st->get_hour_AtmLW();
		temp_Flux_LCLW = st->get_hour_LCLW();
		temp_Flux_BackLW = st->get_hour_BackLW();
		temp_Flux_LW = st->get_hour_Flux_LW();
		temp_Flux_DirSW = st->get_hour_Flux_DirSW();
		temp_Flux_DiffSW = st->get_hour_Flux_DiffSW();
		temp_Flux_SW = st->get_hour_Flux_SW();
		temp_T_Uns = st->get_hour_T_Uns();
		temp_depth_Uns = st->get_hour_depth_Uns();

		//temp_Hyporheic_Exchange = st->getHypEx();
		//temp_Q_GW = st->getQ_GW();
	}

	// The vectors required for the HEC_RAS related calculation method (Jan. 18)
	// start

}


void CoolRiverOutputWriter::calculationMethod3(Inputs* input, std::string inputDirectory, StreamTemperature* st, int& calcMethod, int& TotalDistMod_FD, int& TotalTime_HR, int& TotalDist_Uns)
{
	std::vector<vector<double>> temp_Flux_Evaporation_HR(TotalDistMod_FD, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_Conduction_HR(TotalDistMod_FD, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_Convection_HR(TotalDistMod_FD, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_FLux_AtmLW_HR(TotalDistMod_FD, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_LCLW_HR(TotalDistMod_FD, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_BackLW_HR(TotalDistMod_FD, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_LW_HR(TotalDistMod_FD, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_DirSW_HR(TotalDistMod_FD, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_DiffSW_HR(TotalDistMod_FD, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_SW_HR(TotalDistMod_FD, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_Total_HRdist(TotalDistMod_FD, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Temp_HRdist(TotalDistMod_FD, std::vector<double>(TotalTime_HR));

	std::vector<vector<double>> temp_Flux_Evaporation_Nodes(TotalDist_Uns, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_Conduction_Nodes(TotalDist_Uns, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_Convection_Nodes(TotalDist_Uns, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_FLux_AtmLW_Nodes(TotalDist_Uns, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_LCLW_Nodes(TotalDist_Uns, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_BackLW_Nodes(TotalDist_Uns, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_LW_Nodes(TotalDist_Uns, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_DirSW_Nodes(TotalDist_Uns, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_DiffSW_Nodes(TotalDist_Uns, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_Flux_SW_Nodes(TotalDist_Uns, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_FluxTotal_HR(TotalDist_Uns, std::vector<double>(TotalTime_HR));
	std::vector<vector<double>> temp_HeatFluxADR_Temperature_C(TotalDist_Uns, std::vector<double>(TotalTime_HR));

	// For Debugging purpose-start
	//std::vector<vector<double>> temp_tempNodesDebugg(12, std::vector<double>(96));
	//temp_tempNodesDebugg = st->get_tempNodesDebugg();
	//std::vector<double> tempHyporheic_Exchange_HR(100);
	//tempHyporheic_Exchange_HR = st->getHypEx_HR();
	// For Debugging purpose-end

	if (calcMethod == 3)
	{
		temp_Flux_Evaporation_HR = st->get_EvapHRdist();
		temp_Flux_Conduction_HR = st->get_CondHRdist();
		temp_Flux_Convection_HR = st->get_ConvHRdist();
		temp_FLux_AtmLW_HR = st->get_AtmLWHRdist();
		temp_Flux_LCLW_HR = st->get_LCLWHRdist();
		temp_Flux_BackLW_HR = st->get_BackLWHRdist();
		temp_Flux_LW_HR = st->get_LWHRdist();
		temp_Flux_DirSW_HR = st->get_DirSWHRdist();
		temp_Flux_DiffSW_HR = st->get_DiffSWHRdist();
		temp_Flux_SW_HR = st->get_SWHRdist();
		temp_Flux_Total_HRdist = st->get_TotalFluxHRdist();
		temp_Temp_HRdist = st->get_TempHRdist();

		temp_Flux_Evaporation_Nodes = st->get_EvapHRnodes();
		temp_Flux_Conduction_Nodes = st->get_CondHRnodes();
		temp_Flux_Convection_Nodes = st->get_ConvHRnodes();
		temp_FLux_AtmLW_Nodes = st->get_get_AtmLWHRnodes();
		temp_Flux_LCLW_Nodes = st->get_LCLWHRnodes();
		temp_Flux_BackLW_Nodes = st->get_BackLWHRnodes();
		temp_Flux_LW_Nodes = st->get_LWHRnodes();
		temp_Flux_DirSW_Nodes = st->get_DirSWHRnodes();
		temp_Flux_DiffSW_Nodes = st->get_DiffSWHRnodes();
		temp_Flux_SW_Nodes = st->get_SWHRnodes();
		temp_FluxTotal_HR = st->get_TotalFluxHRnodes();
		temp_HeatFluxADR_Temperature_C = st->get_TempHRnodes();
	}

}

void CoolRiverOutputWriter::swtichCalMethod1True(Inputs *input, StreamTemperature* st, int &TotalDistMod, int &TotalTimeMod)
{
	// Writing the results for the steady state condition
		//Added River Station and time Step Strings as headers for output files
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->T, "Hourly_Temperature_C_deg", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->SWDir_2D, "Hourly_DirectSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->SWDiff_2D, "Hourly_DiffuseSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->atmLW_2D, "Hourly_AtmLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->LCLW_2D, "Hourly_LandcoverLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->backLW_2D, "Hourly_WaterBack2SkyLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->LW_2D, "Hourly_TotalLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->Latent_2D, "Hourly_LatentE_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->Sensible_2D, "Hourly_SensibleE_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->heat_flux_2D, "Hourly_TotalHeatFlux_J_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->SW_2D, "Hourly_TotalSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDistMod, TotalTimeMod, "River Station", "Time step", st->Bed_2D, "Hourly_SedimentConduction_W_per_m2", input->SimulationStringParams["OutputDirectory"]);

}

void CoolRiverOutputWriter::swtichCalMethod1False(Inputs* input, StreamTemperature* st, int& TotalDist_Uns, int& TotalTimeMod_CN)
{
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->t_minBased, "Minutely_Temperature_C_deg", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->heat_flux_2D_min, "Minutely_TotalHeatFlux_J_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->SWDir_2D_min, "Minutely_DirectSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->SWDiff_2D_min, "Minutely_DiffuseSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->SW_2D_min, "Minutely_TotalSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->LW_2D_min, "Minutely_TotalLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->atmLW_2D_min, "Minutely_AtmLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->LCLW_2D_min, "Minutely_LandcoverLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->backLW_2D_min, "Minutely_WaterBack2SkyLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->Latent_2D_min, "Minutely_LatentE_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->Sensible_2D_min, "Minutely_SensibleE_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod_CN - 1) * 60, "River Station", "Time step", st->Bed_2D_min, "Minutely_SedimentConduction_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
}

void CoolRiverOutputWriter::swtichCalMethod3ExtTrue(Inputs* input, StreamTemperature* st, int& TotalDist_Uns_HR, int& TotalTimeModHR)
{
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->DeltaTotal_HR, "Hourly_DeltaTotalHR", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->DepthAvgALL_HR, "Hourly_RiverAvgDepth_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->AreaALL_HR, "Hourly_RiverXSArea_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->VelocityALL_HR, "Hourly_RiverVelocity_m_per_s", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->WidthALL_HR, "Hourly_RiverWidth_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->HeatFluxRetentionTime_p_dt, "Hourly_RiverRetentionTime_s", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Pw_ALL_HR, "Hourly_RiverWettedPerimeter_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->WSElev_ALL_HR, "Hourly_RiverWaterSurfElev_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Q_Str_HR, "Hourly_RiverQDischarge_m3_per_s", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->HyporheicExchange_HR, "Hourly_HyporheicExchange_m3_per_s", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Dispersion_HR, "Hourly_LongDispersion_m2_per_s", input->SimulationStringParams["OutputDirectory"]);

}

void CoolRiverOutputWriter::swtichCalMethod3True(Inputs* input, StreamTemperature* st, int& TotalDist_Uns_HR, int& TotalTimeModHR)
{
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->HeatFluxADR_Temperature_C, "Hourly_Temperature_C_deg", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->FluxTotal_HR, "Hourly_TotalHeatFlux_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Flux_SW_Nodes, "Hourly_TotalSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Flux_DirSW_Nodes, "Hourly_DirectSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Flux_DiffSW_Nodes, "Hourly_DiffuseSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Flux_LW_Nodes, "Hourly_TotalLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Flux_LCLW_Nodes, "Hourly_LandcoverLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Flux_BackLW_Nodes, "Hourly_WaterBack2SkyLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->FLux_AtmLW_Nodes, "Hourly_AtmLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Flux_Convection_Nodes, "Hourly_SensibleE_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Flux_Conduction_Nodes, "Hourly_SedimentConduction_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTimeModHR, "River Station", "Time step", st->Flux_Evaporation_Nodes, "Hourly_LatentE_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
}

void CoolRiverOutputWriter::swtichCalMethod3FalseExtTrue(Inputs* input, StreamTemperature* st, int& TotalDist_Uns_HR, int& TotalTime_HR)
{
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->delta_2D_min, "Minutely_DeltaTotalHR", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->depthAvgALL_2D_min, "Minutely_RiverAvgDepth_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->AreaALL_2D_min, "Minutely_RiverXSArea_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->VelocityALL_2D_min, "Minutely_RiverVelocity_m_per_s", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->WidthALL_2D_min, "Minutely_RiverWidth_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->RetentionT_2D_min, "Minutely_RiverRetentionTime_s", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->Pw_ALL_2D_min, "Minutely_RiverWettedPerimeter_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->WSElev_ALL_2D_min, "Minutely_RiverWaterSurfElev_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->Q_Str_2D_min, "Minutely_RiverQDischarge_m3_per_s", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->HyporheicExchange_2D_min, "Minutely_HyporheicExchange_m3_per_s", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->Dispersion_2D_min, "Minutely_LongDispersion_m2_per_s", input->SimulationStringParams["OutputDirectory"]);
}

void CoolRiverOutputWriter::swtichCalMethod3False(Inputs* input, StreamTemperature* st, int& TotalDist_Uns_HR, int& TotalTime_HR)
{
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->t_minBased, "Minutely_Temperature_C_deg", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->heat_flux_2D_min, "Minutely_TotalHeatFlux_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->SWDir_2D_min, "Minutely_DirectSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->SWDiff_2D_min, "Minutely_DiffuseSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->SW_2D_min, "Minutely_TotalSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->LW_2D_min, "Minutely_TotalLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->atmLW_2D_min, "Minutely_AtmLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->LCLW_2D_min, "Minutely_LandcoverLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->backLW_2D_min, "Minutely_WaterBack2SkyLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->Latent_2D_min, "Minutely_LatentE_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->Sensible_2D_min, "Minutely_SensibleE_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns_HR, TotalTime_HR, "River Station", "Time step", st->Bed_2D_min, "Minutely_SedimentConduction_W_per_m2", input->SimulationStringParams["OutputDirectory"]);

}

void CoolRiverOutputWriter::swtichCalMethod2ExtTrue(Inputs* input, StreamTemperature* st, int& TotalDist_Uns, int& TotalTimeMod)
{
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_depth_Uns, "Hourly_WaterDepth_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Pw_unsteady, "Hourly_WettedPerimeter_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_width_UnsTotal, "Hourly_WaterWidth_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_depth_AvgUns, "Hourly_WaterAvgDepth_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Hyporheic_Exchange, "Hourly_HyporheicExchange", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Rh_unsteady, "Hourly_HydraulicRadius_m", input->SimulationStringParams["OutputDirectory"]);
}

void CoolRiverOutputWriter::swtichCalMethod2True(Inputs* input, StreamTemperature* st, int& TotalDist_Uns, int& TotalTimeMod)
{
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Flux_Total, "Hourly_TotalHeatFlux_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_T_Uns, "Hourly_Temperature_C_deg", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Flux_Conduction, "Hourly_SedimentConduction_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Flux_Evaporation, "Hourly_LatentE_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Flux_Convection, "Hourly_Sensible_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_FLux_AtmLW, "Hourly_AtmLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Flux_LCLW, "Hourly_LandcoverLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Flux_BackLW, "Hourly_WaterBack2SkyLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Flux_LW, "Hourly_TotalLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Flux_DirSW, "Hourly_DirectSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Flux_DiffSW, "Hourly_DiffuseSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, TotalTimeMod, "River Station", "Time step", st->hour_Flux_SW, "Hourly_TotalSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
}

void CoolRiverOutputWriter::swtichCalMethod2FalseExtTrue(Inputs* input, StreamTemperature* st, int& TotalDist_Uns, int& TotalTimeMod)
{
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->depth_Uns, "Minutely_RiverDepth_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->Pw_unsteady_2D_min, "Minutely_RiverWettedPerimeter_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->width_UnsTotal_2D_min, "Minutely_RiverWidth_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->depth_AvgUns_2D_min, "Minutely_RiverAvgDepth_m", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->Hyporheic_Exchange_2D_min, "Minutely_HyporheicExchange_m3_per_s", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->Rh_unsteady_2D_min, "Minutely_HydraulicRadius_m", input->SimulationStringParams["OutputDirectory"]);
}

void CoolRiverOutputWriter::swtichCalMethod2False(Inputs* input, StreamTemperature* st, int& TotalDist_Uns, int& TotalTimeMod)
{
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->t_minBased, "Minutely_Temperature_C_deg", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->heat_flux_2D_min, "Minutely_TotalHeatFlux_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->Bed_2D_min, "Minutely_SedimentConduction_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->Latent_2D_min, "Minutely_LatentE_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->Sensible_2D_min, "Minutely_SensibleE_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->atmLW_2D_min, "Minutely_AtmLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->LCLW_2D_min, "Minutely_LandcoverLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->backLW_2D_min, "Minutely_WaterBack2SkyLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->LW_2D_min, "Minutely_TotalLW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->SWDir_2D_min, "Minutely_DirectSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->SWDiff_2D_min, "Minutely_DiffuseSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
	twoDwriter(TotalDist_Uns, (TotalTimeMod - 1) * 60, "River Station", "Time step", st->SW_2D_min, "Minutely_TotalSW_W_per_m2", input->SimulationStringParams["OutputDirectory"]);
}


void CoolRiverOutputWriter::twoDwriter(int sizeX, int sizeY, string a, string b, vector<vector<double>>& vector, string title, string OutputDir)
{

	title = OutputDir + "\\2D_" + title + ".csv";
	ofstream outfileC(title);

	if (!outfileC.good())
	{
		std::ofstream logfile("log.txt", ios::app);
		logfile << "Cannot write the output file: " + title;
		logfile << "\n";
		logfile.close();
		std::cout << "Cannot write the output file" << std::endl;
		return;
	}
	vector.resize(sizeX);
	//adding row and column headers for the output files.
	outfileC << ",";
	//k is representing time step to handle in separate loop
	for (int k = 0; k < sizeY; k++)
	{
		//taking string values as an input to column headers
		outfileC << b
			<< "_" << k << ",";
	}
	outfileC << '\n';

	for (int i = 0; i < sizeX; i++)
	{
		//taking string values as an input to row headers
		outfileC << a << "_" << i
			<< ",";
		vector[i].resize(sizeY);
		for (int j = 0; j < sizeY; j++)
		{
			//taking the 2D vectors as output i = river station, j = time step
			outfileC << vector[i][j] << ",";
		}
		//next line
		outfileC << '\n';
	}
	std::ofstream logfile2("log.txt", ios::app);
	logfile2 << "Finished Writing Output file: " + title;
	logfile2 << "\n";
	logfile2.close();
}