#pragma once
#include "../Inputs/Inputs.h"
#include "../DataFolder.h"
#include <fstream>
#include <iomanip>
#include <iostream>

class GIOutputWriter
{
public:
	// BulkArea
	static void writeVegCanopyFile_VWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeVegCanopyFile_FWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterOnPerAreaFile_VWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterOnPerAreaFile_FWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterOnImpAreaFile_VWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterOnImpAreaFile_FWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_VWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeEvap_ET_Infil_FWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterInRootZone_VWB_BulkArea(Inputs *input, DataFolder *folder);
	static void writeWaterInRootZone_FWB_BulkArea(Inputs *input, DataFolder *folder);

	//Creating generic GI waterbalance output shared by all GI devices
	//GI Area
	static void writeWaterInRootZone_VWB_GIArea(Inputs* input, DataFolder* folder);

	//Rain Garden
	static void writeWaterBalance_RainGarden(Inputs *input, DataFolder *folder);

	//BioRetention
	static void writeWaterBalance_BioRetention(Inputs *input, DataFolder *folder);

	//InfilTrench
	static void writeWaterBalance_InfilTrench(Inputs *input, DataFolder *folder);

	//Swale
	static void writeWaterBalance_Swale(Inputs *input, DataFolder *folder);

	//Porous Pavement  
	static void writeWaterBalance_PermeablePavement(Inputs* input, DataFolder* folder);
	
	//Green Roof
	static void writeWaterBalance_GreenRoof(Inputs* input, DataFolder* folder);

	//Rooftop disconnection
	static void writeWaterBalance_RoofDiscon(Inputs* input, DataFolder* folder);
	
	// Rain Barrel - Need to modify the below functions if needed
	static void writeWaterBalance_RainBarrel(Inputs* input, DataFolder* folder);

	//Water budget
	static void waterbudget(Inputs* input, DataFolder* folder);
};