#pragma once
#include <vector>
#include "calibrate.h"
#include "../Inputs/Inputs.h"
#include "../DataFolder.h"
#include "../DataOrganizer.h"
#include <fstream>
#include <iomanip>
#include <iostream>

using namespace std;

class SpatialOutputWriter
{
	public:
		static void writeOutputFile(std::string indirectory, Inputs *input, DataOrganizer *organizer, DataFolder *folder);
		static vector<double> hourlyToDaily(const vector<double>& input);
		static double hourlyToDailyVal(const vector<double>& input, const int i);
		static vector<double> hourlyToWeekly(const vector<double>& input);
		static double hourlyToWeeklyVal(const vector<double>& input, const int i);
		static vector<double> hourlyToMonthly(const vector<double>& input);
		static double hourlyToMonthlyVal(const vector<double>& input, const int i);
		static std::vector<double> convertToTimeStep(const std::vector<double>& val, const std::string timeStep);
		static vector<int> getDailyDate(const std::vector<int> date);	
		static vector<int> getWeeklyDate(const std::vector<int> date);
		static vector<int>  getMonthlyDate(const std::vector<int> date);
		static vector<string> getDailyHHMMSS(const std::vector<string> HHMMSS, const std::vector<int> date);
		static vector<string> getWeeklyHHMMSS(const std::vector<string> HHMMSS, const std::vector<int> date);
		static vector<string> getMonthlyHHMMSS(const std::vector<string> HHMMSS, const std::vector<int> date);
};