#ifndef UNSATMD2_H
#define UNSATMD2_H
////////////////////////////////////////////////////////////////////////////////////////
//																		              //
// LocalSoilMoistureCalc.h - Calculates unsaturated zone               //
// soil moisture deficit with exponential decay                                       //																		   
// ver 1.0                                                                            //
// Language:    Visual C++ 2010                                                       //
// Platform:    MacBookPro5,4  Win7										              //
// Application: HydroPrime/iHydro Version6, Summer 2012                               //
// Programmer:  				              //																	   	
////////////////////////////////////////////////////////////////////////////////////////
/*
  Module Operations: 
  ==================
  Calculates local soil moisture deficit for each ln(a/tanB) increment. 
 */
#include "../Inputs/Inputs.h"
#include "../DataFolder.h"


class LocalSoilMoistureCalc
{
	public:
		static void calculate(Inputs *input, DataFolder *folder, int timeStep); 
		static void storeValues(Inputs* input, DataFolder* folder, int timeStep);
};



#endif





// see UnsatZoneSoilMoistureDeficit.h for interface
// remeber to make inputs repository and results repository a friend of this class...inputsrepository.cpp resultsrepository.cpp
// see UnsatZoneSoilMoistureDeficit.cpp for implentation help 
// incporporate equation from Version 5 line 49 void runsatzoneE::localSoilMD () {