#ifndef TestSimulation_H
#define TestSimulation_H
#include "Inputs\Inputs.h"
#include "DataOrganizer.h"
#include "LogMessage.h"
//Optional paths to pugixml and pugiconfig for use of pugixml, alternative to Jim Fawcet's XMLReader
#include "XMLReader\pugixml.hpp"
#include "XMLReader\pugiconfig.hpp"


class TestSimulation
{
public:
	static void Go(DataOrganizer *organizer, Inputs *input, std::string inputDirectory);
	static void RunStatisticalModel(DataOrganizer *organizer, Inputs *input, std::string inputDirectory);
	static void RunTemperatureSpatialModel(DataOrganizer *organizer, Inputs *input, std::string inputDirectory);
	static void RunCoolRiverModel(DataOrganizer *organizer, Inputs *input, std::string inputDirectory);

private:
	static void runCalculations(DataFolder* folder, Inputs* input, int timeStep, std::vector<DataFolder*> &stafolders);
	static void runProcesses(DataFolder *folder, Inputs *input, int timeStep, std::vector<DataFolder*> &stafolders);
};

#endif